---
{% if domain_name_enable %}
networks:
  backend:
    name: backend
    external: true
  frontend:
    name: frontend
    external: true
{% endif %}

services:
  # https://github.com/pi-hole/docker-pi-hole/blob/master/README.md
  pihole:
    container_name: pihole
    image: pihole/pihole:latest
    restart: unless-stopped
    ports:
      - "53:53/tcp"
      - "53:53/udp"
{% if domain_name_enable and domain_name and domain_pihole %}
      - "38080:80/tcp"
{% else %}
      - "80:80/tcp"
{% endif %}
    environment:
      FTLCONF_LOCAL_IPV4: "{{ ansible_facts['default_ipv4']['address'] }}"
      TZ: "{{ pihole_timezone }}"
      WEBPASSWORD: "{{ pihole_password }}"
      PIHOLE_DNS_: '9.9.9.9;149.112.112.112'
      FTLCONF_BLOCK_ICLOUD_PR: false
{% if domain_name_enable and domain_name and domain_pihole %}
      VIRTUAL_HOST: "{{ domain_pihole }}.{{ domain_name }}"
      VIRTUAL_PORT: 80
      PROXY_LOCATION: "{{ domain_pihole }}"
    networks:
      - frontend
{% endif %}
    dns:
      - 127.0.0.1
      - 9.9.9.9
    volumes:
      - './etc-pihole:/etc/pihole'
      - './etc-dnsmasq.d:/etc/dnsmasq.d'
    # https://github.com/pi-hole/docker-pi-hole#note-on-capabilities
    cap_add:
      - NET_ADMIN
{% if domain_name_enable and domain_name %}
    # adds hostname mappings to pihole /etc/hosts file
    extra_hosts:
      # # LAN hostnames for other docker containers using caddy
      - "{{ domain_name }}:{{ ansible_facts['default_ipv4']['address'] }}"
{% if domain_name_enable and domain_name and domain_pihole %}
      - "{{ domain_pihole }}.{{ domain_name }}:{{ ansible_facts['default_ipv4']['address'] }}"
{% endif %}
{% if domain_name_enable and domain_name and domain_grafana %}
      - "{{ domain_grafana }}.{{ domain_name }}:{{ ansible_facts['default_ipv4']['address'] }}"
{% endif %}
{% if domain_name_enable and domain_name and domain_prometheus %}
      - "{{ domain_prometheus }}.{{ domain_name }}:{{ ansible_facts['default_ipv4']['address'] }}"
{% endif %}
{% endif %}

  pihole-exporter:
    container_name: pihole-exporter
    image: ekofr/pihole-exporter:latest
    restart: always
    hostname: 'pihole-exporter'
    environment:
      PIHOLE_HOSTNAME: "{{ pihole_hostname }}"
      PIHOLE_PASSWORD: "{{ pihole_password }}"
      INTERVAL: '30s'
      PORT: 9617
    networks:
      - backend
      - frontend
